import React from 'react';
import { Meta } from '@storybook/react';
import { SemSubstrVisComponent } from './semanticsubstratesvis';
import { graphQueryResultSlice, querybuilderSlice, schemaSlice, visualizationSlice } from '../../../data-access/store';
import { configureStore } from '@reduxjs/toolkit';
import { Provider } from 'react-redux';
import { mockData } from '../../../mock-data';

const Mockstore = configureStore({
  reducer: {
    schema: schemaSlice.reducer,
    graphQueryResult: graphQueryResultSlice.reducer,
    visualize: visualizationSlice.reducer,
    querybuilder: querybuilderSlice.reducer,
  },
});

const Component: Meta<typeof SemSubstrVisComponent.component> = {
  title: 'Visualizations/SemanticSubstrates',
  component: SemSubstrVisComponent.component,
  decorators: [
    (story) => (
      <Provider store={Mockstore}>
        <div
          style={{
            width: '100%',
            height: '100vh',
          }}
        >
          {story()}
        </div>
      </Provider>
    ),
  ],
};

export const TestWithBig2ndChamber = {
  args: {
    ...(await mockData.big2ndChamberQueryResult()),
    settings: SemSubstrVisComponent.settings,
  },
};

export const TestWithRecommendationsActorMovie = {
  args: {
    ...(await mockData.mockRecommendationsActorMovie()),
    settings: SemSubstrVisComponent.settings,
  },
};

export const TestWithGOTcharacter2character = {
  args: {
    ...(await mockData.gotCharacter2Character()),
    settings: SemSubstrVisComponent.settings,
  },
};

export default Component;
